# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetDLPIncidentReceiverServersResult',
    'AwaitableGetDLPIncidentReceiverServersResult',
    'get_dlp_incident_receiver_servers',
    'get_dlp_incident_receiver_servers_output',
]

@pulumi.output_type
class GetDLPIncidentReceiverServersResult:
    """
    A collection of values returned by getDLPIncidentReceiverServers.
    """
    def __init__(__self__, flags=None, id=None, name=None, status=None, url=None):
        if flags and not isinstance(flags, int):
            raise TypeError("Expected argument 'flags' to be a int")
        pulumi.set(__self__, "flags", flags)
        if id and not isinstance(id, int):
            raise TypeError("Expected argument 'id' to be a int")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)
        if url and not isinstance(url, str):
            raise TypeError("Expected argument 'url' to be a str")
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def flags(self) -> int:
        return pulumi.get(self, "flags")

    @property
    @pulumi.getter
    def id(self) -> int:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def status(self) -> str:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def url(self) -> str:
        return pulumi.get(self, "url")


class AwaitableGetDLPIncidentReceiverServersResult(GetDLPIncidentReceiverServersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDLPIncidentReceiverServersResult(
            flags=self.flags,
            id=self.id,
            name=self.name,
            status=self.status,
            url=self.url)


def get_dlp_incident_receiver_servers(name: Optional[str] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDLPIncidentReceiverServersResult:
    """
    Use the **zia_dlp_incident_receiver_servers** data source to get information about a ZIA DLP Incident Receiver Server in the Zscaler Internet Access cloud or via the API.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_zia as zia

    this = zia.get_dlp_incident_receiver_servers(name="ZS_Incident_Receiver")
    ```
    <!--End PulumiCodeChooser -->


    :param str name: The DLP Incident Receiver Server name as configured by the admin.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zia:index/getDLPIncidentReceiverServers:getDLPIncidentReceiverServers', __args__, opts=opts, typ=GetDLPIncidentReceiverServersResult).value

    return AwaitableGetDLPIncidentReceiverServersResult(
        flags=pulumi.get(__ret__, 'flags'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        status=pulumi.get(__ret__, 'status'),
        url=pulumi.get(__ret__, 'url'))


@_utilities.lift_output_func(get_dlp_incident_receiver_servers)
def get_dlp_incident_receiver_servers_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDLPIncidentReceiverServersResult]:
    """
    Use the **zia_dlp_incident_receiver_servers** data source to get information about a ZIA DLP Incident Receiver Server in the Zscaler Internet Access cloud or via the API.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_zia as zia

    this = zia.get_dlp_incident_receiver_servers(name="ZS_Incident_Receiver")
    ```
    <!--End PulumiCodeChooser -->


    :param str name: The DLP Incident Receiver Server name as configured by the admin.
    """
    ...
